function [d0] = TradeCosts (T,PARA)

    n=size(PARA.PolygonNeig,1);

    A=T.^(-PARA.omega);
    I=eye(n);
    B=(I-A)^(-1);
   
    c=gamma((PARA.omega-1)/PARA.omega);
    d0=c.*B.^(-1./PARA.omega);

    
    % spectral radius condition
    rho = max(abs(eig(A)));
    if rho >= 1
        error('Spectral radius <1 condition')
        rho
    end
    
    if isreal(d0)~=1
        disp('Error: Trade costs are not real')
        stop
    end

    if all(sum(A,2) < 1)~=1 %Spectral radius must be <1
        if isfinite(d0)~=1
            disp('Error: Spectral Radius >1 & Matrix is not finite')
        end
    end
    if all(sum(PARA.PolygonNeig,2) > 0)~=1 %All locations must have a connection
        disp('Error: some locations are not connected to the road network')
    end
    if issymmetric(PARA.PolygonNeig)~=1 %Adjacency matrix must be symmetric
            disp('Error: polygon matrix must be symmetric!')
    end

end
