
%
% Check Gradients
%
clear

path='G:\Public Economics\Forschung\GRW Projekt\Paper\BlouriEhrlich2017\ModelSol3without1000';
%load([path '\output\mat\Results_2013_KAPPA1.mat']);
load([path '\output\mat\Results_2013_KAPPA1_Reg9AT.mat']);

cd 'G:\Public Economics\Forschung\GRW Projekt\Paper\BlouriEhrlich2017\ModelSol3without1000';

PARA.opimization='Productivity'; % 'Productivity' or 'IncomeTrans' or 'Transport'
PARA.StableVariance='YesNomIncome'; % YesNomIncome
PARA.opimizationGUESS='Full'; % 'Full' or 'Reduced'

PARA.StableVarianceVal=0.433123721957402; % For productivity

PARA_out
PARA.WBAR=1e-6;
PARA.scaling=0.99;

clear x
lambda1_l = sym('lambda1_l%d', [n 1]);
w1_l = sym('w1_l%d', [n 1]);
pi1_l = sym('pi1_l%d', [n 1]);
TS1_l = sym('TS1_l%d', [n 1]);
V1_l = sym('V1_l%d', [1 1]);
TBAR_l = sym('TBAR_l%d', [1 1]);

x(1:n,1)=lambda1_l;
x(1*n+1:2*n,1)=w1_l;
x(2*n+1:3*n,1)=pi1_l; %This is pi_nn (not pi_ni)!
x(3*n+1:4*n,1)=TS1_l;
x(4*n+1,1)=V1_l;
x(4*n+2,1)=TBAR_l;

ceq=cons_eq(x,PARA);
gradceq = jacobian(ceq,[lambda1_l;w1_l;pi1_l;TS1_l;V1_l;TBAR_l])'; % column gradf

%[feq,t]=func(x,PARA);
%gradfeq = jacobian(feq,[lambda1_l;w1_l;pi1_l;TS1_l;V1_l;TBAR_l])'; % column gradf

lambda1_l1 = 0.2;
lambda1_l2 = 0.25;
lambda1_l3 = 0.1;
lambda1_l4 = 0.15;
lambda1_l5 = 0.15;
lambda1_l6 = 0.05;
lambda1_l7 = 0.05;
lambda1_l8 = 0.02;
lambda1_l9 = 0.03;

w1_l1 = 1253;
w1_l2 = 46589;
w1_l3 = 25688;
w1_l4 = 58965;
w1_l5 = 328568;
w1_l6 = 398568;
w1_l7 = 318568;
w1_l8 = 40;
w1_l9 = 74562;

pi1_l1 = 0.7;
pi1_l2 = 0.85;
pi1_l3 = 0.95;
pi1_l4 = 0.6;
pi1_l5 = 0.68;
pi1_l6 = 0.88;
pi1_l7 = 0.98;
pi1_l8 = 0.5;
pi1_l9 = 0.7;

TS1_l1 = 0.1;
TS1_l2 = 0.15;
TS1_l3 = 0.35;
TS1_l4 = 0.15;
TS1_l5 = 0.1;
TS1_l6 = 0.05;
TS1_l7 = 0.05;
TS1_l8 = 0.02;
TS1_l9 = 0.03;

V1_l11 = 0.8;
TBAR_l11 = 5;

GUESS=[0.2,0.25,0.1,0.15,0.15,0.05,0.05,0.02,0.03,1253,46589,25688,58965,328568,398568,318568,40,74562,0.7,0.85,0.95,0.6,0.68,0.88,0.98,0.5,0.7,0.1,0.15,0.35,0.15,0.1,0.05,0.05,0.02,0.03,0.8,5]';
%GUESS=[0.2,0.4,0.1,1253,46589,25688,0.7,0.85,0.95,0.1,0.25,0.35,0.8,5]';

%feq_sym=double(vpa(eval(gradfeq)));
%[tttt,feq_num]=func(GUESS, PARA);

%addpath(genpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\ADMAT-2.0'));
myfun = ADfun('cons_eq');
options = setgradopt('forwprod', size(GUESS,1));
[F, GCeq] = feval(myfun, GUESS, PARA, options);
GCeq=GCeq';

ceq_sym=double(vpa(eval(gradceq)));
ceq_num=cons_gradient(GUESS, PARA);

i=1;
[ceq_sym(:,i) ceq_num(:,i) ceq_sym(:,i)-ceq_num(:,i)]

%gradceq(1,1)
%cons_a_eq(GUESS,PARA)
%cons_a_gradient(GUESS,PARA)
%A=(f1-f2)

ceq_sym-ceq_num
GCeq-ceq_num

max(max(abs(ceq_sym-ceq_num)))
max(max(abs(GCeq-ceq_num)))
max(max(abs(GCeq-ceq_sym)))
max(max(abs((GCeq-ceq_sym)./GCeq)))




%
% Automatic Differtiation
%
PARA.opimization='Transport'; % 'Productivity' or 'IncomeTrans' or 'Transport' or 'Complete'
PARA.opimizationGUESS='Full'; % 'Full' or 'Reduced'
PARA.StableVariance='YesNomIncome'; % 'YesNomIncome' or 'No'

%Herausladen
tic
[val,val2,Jac,Jac2]=cons(GUESS,PARA);
toc

%Full AD
tic
myfun = ADfun('cons_eq',1);
options = setgradopt('forwprod', size(GUESS,1));
[F, GCeq] = feval(myfun, GUESS, PARA, options);
GCeq=GCeq';
toc

%max(max((abs(GCeq-GCeq3'))))
max(max(abs(((GCeq-Jac2)))))
max(max(abs(((GCeq-Jac2)./GCeq))))




GCeq-Jac2

GCeq


asdfasdf

tic
PARA2=[];
myfun = ADfun('cons_eq2',1);
options = setopt('revprod', eye(3*(size(GUESS,1)-2)/4+4)); %% forwprod, revprod
[F, GCeq] = feval(myfun, GUESS, PARA, options);
toc
%GCeq=GCeq';

max(max(abs(GCeq-ceq_sym)))





