
%
% Check Gradients
%
clear

path='G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication';
load([path '\output\mat\Results_2013_KAPPA1.mat']);
cd 'G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication';

PARA_out
PARA.WBAR=1e-6;
PARA.KAPPA=0.000000001;
kappa=PARA.KAPPA;
PARA.psi=0.97;
PARA.xi=0.5;

clear x
lambda1_l = sym('lambda1_l%d', [n 1]);
w1_l = sym('w1_l%d', [n 1]);
pi1_l = sym('pi1_l%d', [n 1]);
TS1_l = sym('TS1_l%d', [n 1]);
V1_l = sym('V1_l%d', [1 1]);
TBAR_l = sym('TBAR_l%d', [1 1]);

x(1:n,1)=lambda1_l;
x(1*n+1:2*n,1)=w1_l;
x(2*n+1:3*n,1)=pi1_l; %This is pi_nn (not pi_ni)!
x(3*n+1:4*n,1)=TS1_l;
x(4*n+1,1)=V1_l;
x(4*n+2,1)=TBAR_l;

ceq=cons_d_eq(x,PARA);
gradceq = jacobian(ceq,[lambda1_l;w1_l;pi1_l;TS1_l;V1_l;TBAR_l])'; % column gradf

[feq,t]=func(x,PARA);
gradfeq = jacobian(feq,[lambda1_l;w1_l;pi1_l;TS1_l;V1_l;TBAR_l])'; % column gradf

lambda1_l1 = 0.2;
lambda1_l2 = 0.4;
lambda1_l3 = 0.1;
lambda1_l4 = 0.15;
lambda1_l5 = 0.15;

w1_l1 = 1253;
w1_l2 = 46589;
w1_l3 = 25688;
w1_l4 = 58965;
w1_l5 = 328568;

pi1_l1 = 0.7;
pi1_l2 = 0.85;
pi1_l3 = 0.95;
pi1_l4 = 0.6;
pi1_l5 = 0.68;

TS1_l1 = 0.1;
TS1_l2 = 0.25;
TS1_l3 = 0.35;
TS1_l4 = 0.2;
TS1_l5 = 0.1;

V1_l11 = 0.8;
TBAR_l11 = 5;

GUESS=[0.2,0.4,0.1,0.15,0.15,1253,46589,25688,58965,328568,0.7,0.85,0.95,0.6,0.68,0.1,0.25,0.35,0.2,0.1,0.8,5]';
%GUESS=[0.2,0.4,0.1,1253,46589,25688,0.7,0.85,0.95,0.1,0.25,0.35,0.8,5]';

%feq_sym=double(vpa(eval(gradfeq)));

[tttt,feq_num]=func(GUESS, PARA);

ceq_sym=double(vpa(eval(gradceq)));
ceq_num=cons_d_gradient(GUESS, PARA);

i=12;
[ceq_sym(:,i) ceq_num(:,i) ceq_sym(:,i)-ceq_num(:,i)]
















%
% Check d d0 / d T
%

clear

path='G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication';
load([path '\output\mat\Results_2013_KAPPA1.mat']);
cd 'G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication';


PARA_out
PARA.WBAR=1e-6;
PARA.KAPPA=0.000000001;
kappa=PARA.KAPPA;
PARA.psi=0.97;
PARA.xi=0.5;

PARA.omega=136.13; %Allen Arkolakis 2017
PARA.KAPPA_AA=0.0108; %Allen Arkolakis 2017
PARA.KAPPA_AA=0.0308; %Trade Costs have to be sufficiently large such that spectral radius >1


%PolygonNeig(1,3)=1;
%PolygonNeig(3,1)=1;

if n<=5
    TS1_l = sym('TS1_l%d', [1 n]);
    TS1_l = repmat(TS1_l,[n,1]).*PARA.PolygonNeig;
    TS1_l(PARA.PolygonNeig==0)=inf;
    ceq=TradeCosts(TS1_l,PARA);
    ceq=reshape(ceq,[n*n,1]);

    TS1_l = sym('TS1_l%d', [n 1]);
    %TS1_l=reshape(TS1_l,[n*n,1]);
    gradceq = jacobian(ceq,TS1_l)'; % column gradf
end

denum=1;

TS1_l1 = droad0(2,1)./denum;
TS1_l2 = droad0(1,2)./denum;
TS1_l3 = droad0(5,3)./denum;
TS1_l4 = droad0(5,4)./denum;
TS1_l5 = droad0(4,5)./denum;

TS1=[TS1_l1,TS1_l2,TS1_l3,TS1_l4,TS1_l5]';

% TS1_l21 = droad0(2,1)./denum;
% %TS1_l22 = droad0(2,2)./denum;
% %TS1_l23 = droad0(2,3)./denum;
% %TS1_l24 = droad0(2,4)./denum;
% %TS1_l25 = droad0(2,5)./denum;
% 
% %TS1_l31 = droad0(3,1)./denum;
% %TS1_l32 = droad0(3,2)./denum;
% %TS1_l33 = droad0(3,3)./denum;
% %TS1_l34 = droad0(3,4)./denum;
% TS1_l35 = droad0(3,5)./denum;
% 
% %TS1_l41 = droad0(4,1)./denum;
% %TS1_l42 = droad0(4,2)./denum;
% %TS1_l43 = droad0(4,3)./denum;
% %TS1_l44 = droad0(4,4)./denum;
% TS1_l45 = droad0(4,5)./denum;
% 
% TS1_l51 = droad0(5,1)./denum;
% %TS1_l52 = droad0(5,2)./denum;
% TS1_l53 = droad0(5,3)./denum;
% TS1_l54 = droad0(5,4)./denum;
% %TS1_l55 = droad0(5,5)./denum;



%TBAR_l11 = 5;
%TS1=[TS1_l11,TS1_l21,TS1_l31,TS1_l41,TS1_l51,TS1_l12,TS1_l22,TS1_l32,TS1_l42,TS1_l52,TS1_l13,TS1_l23,TS1_l33,TS1_l43,TS1_l53,TS1_l14,TS1_l24,TS1_l34,TS1_l44,TS1_l54,TS1_l15,TS1_l25,TS1_l35,TS1_l45,TS1_l55];

%TS1=sum(reshape(TS1,[n,n]))./sum(PolygonNeig);
%TradeCosts(reshape(TS1,[n,n]),PARA)

%TS1=[TS1_l11,TS1_l21,TS1_l31,TS1_l41,1.2.*TS1_l51,TS1_l12,TS1_l22,TS1_l32,TS1_l42,TS1_l52,TS1_l13,TS1_l23,TS1_l33,TS1_l43,TS1_l53,TS1_l14,TS1_l24,TS1_l34,TS1_l44,TS1_l54,TS1_l15,TS1_l25,TS1_l35,TS1_l45,TS1_l55];
%A=TradeCosts(reshape(TS1,[n,n]),PARA)
%TS1=[TS1_l11,TS1_l21,TS1_l31,TS1_l41,TS1_l51,TS1_l12,TS1_l22,TS1_l32,TS1_l42,TS1_l52,TS1_l13,TS1_l23,TS1_l33,TS1_l43,TS1_l53,TS1_l14,TS1_l24,TS1_l34,TS1_l44,TS1_l54,TS1_l15,TS1_l25,TS1_l35,TS1_l45,TS1_l55];
%TS1=[TS1_l12, TS1_l15, TS1_l21, TS1_l35, TS1_l45, TS1_l51, TS1_l53, TS1_l54]

B=TradeCosts(droad0,PARA)
PARA.d0=B;

reshape(double(vpa(eval(ceq))),[n,n])
% B=TradeCosts2(PARA.droad0./60,PARA)
% 
% reshape(TS1,[n,n])

%A-B

ceq_sym=double(vpa(eval(gradceq)));




path='G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication';
kappa_file='0.975';
    load([path '\output\mat\Results_2013_KAPPA' kappa_file '.mat']);
cd 'G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication';
    
    PARA_out
    PARA.WBAR=1e6;

      pd = makedist('Normal',0,1e9);
    TS1=random(pd,n,1);
    TS1=abs(TS1);
    TS1 = TS1./sum(TS1);

    PARA.TS1=TS1;
    [Utility_ch,PARA]=solveCounterfactual_w(PARA);
    TBAR=sum(PARA.w_ch.*PARA.w0.*PARA.L_ch.*PARA.L0.*PARA.t1);

    PARA.lambda1=PARA.lambda_ch.*PARA.lambda0;
    PARA.L1=PARA.L_ch.*PARA.L0;
    PARA.w1=PARA.w_ch.*PARA.w0;
    PARA.v1=PARA.v_ch.*PARA.v0;
    PARA.pi1=PARA.pi_ch.*PARA.pi0;

    
    
    %
    % Form GUESS
    %
    GUESS(1:1*n,1) = PARA.lambda1; 
    GUESS(1*n+1:2*n,1) = PARA.w1./PARA.WBAR; 
    GUESS(2*n+1:3*n,1) = diag(PARA.pi1); 
    GUESS(3*n+1:4*n,1) = PARA.TS1;
    GUESS(4*n+1,1) =  PARA.CONST*PARA.LBAR.^(-alpha/(1-sigma)-(1-alpha))*delta*gamma.*B0(1).^(1/epsilon).*(((a0(1).*PARA.v1(1))./(diag(d0(1)).*PARA.w1(1))).^(alpha)).*(PARA.pi1(1).^(alpha/(1-sigma))).*(H0(1).^(1-alpha)).*((1./PARA.lambda1(1)).^((alpha*epsilon+(1-alpha)*(1-sigma)*epsilon+(1-sigma))/((1-sigma)*epsilon)));
    GUESS(4*n+2,1) =  sum(PARA.w1.*PARA.L1.*PARA.t1)./PARA.TBAR;
   
    %
    % Form GUESS NEW Reduced
    %
    GUESS=[];
    GUESS(1:1*n,1) = PARA.lambda_ch; 
    GUESS(1*n+1:2*n,1) = PARA.w_ch; 
    GUESS(2*n+1:3*n,1) = ones(n,1); %TS_ch
    GUESS(3*n+1,1) =  Utility_ch(1);
    GUESS(3*n+2,1) =  PARA.TBAR_ch;
    
    
    max(cons_eq(GUESS,PARA))
    min(cons_eq(GUESS,PARA))

    othersolvingmethod_fmincon
    options_knitro
   
    
    
    %%%
    %%% Numerical Jacobian
    %%% 
    J=[];
    x=GUESS;
    n=length(x);
    %f=@(w0) sum(w0.*PARA.WBAR.*PARA.lambda0.*PARA.LBAR.*PARA.t0);
    f=@(x) cons_eq(x,PARA);
    fx=feval(f,x);
    eps=1.e-8;  % could be made better
    xperturb=x;
    for i=1:n
        xperturb(i)=xperturb(i)+eps;
        J(:,i)=(feval(f,xperturb)-fx)/eps;
        xperturb(i)=x(i);
    end;
    J=J';
    TJ=cons_gradient(x,PARA);
    
    %%%
    %%%Complex Step Differentiation
    %%%
    A=[]
    A2=[]    
    F=@(x) cons_eq(x,PARA);
	Fpc = @(x,h) imag(F(x))/h;

    h = 10.^(-8);
    j=0;
    clear i
    for k=1:length(GUESS)
        j=j+1;
        GUESS1=GUESS;
        GUESS2=GUESS;
        GUESS3=GUESS;

        GUESS1(k,1)=i*h.*GUESS(k,1);
        A(j,:)=Fpc(GUESS1,h)';

        GUESS2(k,1)=GUESS(k,1)+h;
        GUESS3(k,1)=GUESS(k,1)-h;
        A2(j,:)=((F(GUESS2) - F(GUESS3))/(2*h))';
    end
    
    %%%
    %%%AutoDiff Master
    %%%
    addpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\MatlabAutoDiff-master\src\');

    f=@(x) [sin(x(1)) cos(x(2)) tan(x(1)*x(2))];
    JAD=full(AutoDiffJacobianAutoDiff(f,[1,1]))

    f=@(x) cons_eq(x,PARA);
    tic
    JAD=full(AutoDiffJacobianAutoDiff(f,GUESS))';
    toc
    tic
    JFD=full(AutoDiffJacobianFiniteDiff(f,GUESS))';
    toc
    
	%
    % Opti-Toolbox
    %
    run('G:\Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/OPTI-master/opti_Install');
    fun = @(x) x(1)*x(4)*(x(1) + x(2) + x(3)) + x(3);
    f=@(x) cons_eq(x,PARA);
    % Initial Point
    x0 = [1;2;3;4];

    % Numerically Differentiate
    tic
    df = mklJac(f,GUESS)';
    toc
    % Automatic Differentiation
    tic
    dfa = autoJac(f,GUESS)';
    toc
    
    % Complex Step Differentiation
    tic
    dfc = cstepJac(f,GUESS)';
    toc
    
    
    
    tic
    GCeq = cons_gradient(GUESS,PARA);
    toc
    
    % Automatic Differentiation
	tic
    addpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\MatlabAutoDiff-master\src\');
    f=@(x) cons_eq_a_ch2(x,PARA);
    JAD=full(AutoDiffJacobianAutoDiff(f,GUESS))';
	toc 
    
    
    %
    % Adigator
    %
	run('G:\Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/adigator/startupadigator');
    solveflag = exist('fmincon','file');
    % --------------------- Call adigatorGenFiles4Fmincon ------------------- %
    n=264;
    setup.order = 1;
    setup.numvar = 3*n+2;
    setup.objective  = 'func_eq';
    setup.constraint = 'cons_eq_w_ch3';
    setup.auxdata = PARA
    adifuncs = adigatorGenFiles4Fmincon(setup);

    tic
    [D]=cons_eq_w_ch3_Jac(GUESS,PARA);
    toc
   
    size(JAD)
    size(full(D))    
    
    sum(sum(abs(JAD-full(D))))

    %
    % ADMAT 2.0
    %
	run('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\ADMAT-2.0\startup.p')
    myfun = ADfun('func_eq',1)
    myfun = ADfun('cons_eq_a_ch2',3*n+2)
    x = ones(3*n+2,1);
    display('Compute gradient of a Brown function.');
    [f, grad] = feval(myfun, x, PARA)
    
    
    myfun = ADfun('brown',1);
    %  Set the dimension of x
    n = 5;
    % Initialize vector x
    %  Define x to be an all one vector
    x = ones(n,1);
    display('Compute gradient of a Brown function.');
    %  Compute the gradient of Brown function
    [f, grad] = feval(myfun, x)

    display('Compute function value and J, Jacobian of broyden at x');
    [F, J] = feval(myfun, x)
    
    display('Compute function value and  J*V at x by forward mode');
    V = ones(n,3);
    options = setopt('forwprod', V);
    %  call feval to compute the function value and JV with new set up
    %  "option"
    [F, JV] = feval(myfun, x, [], options)
    %
    % using the reverse mode to compute JTW via calling feval
    %
    % set up the argument option to be reverse mode and W
    display('Compute function value and  J^T*W at x by reverse mode');
    W = ones(n,3);
    options = setopt('revprod', W);
    % call feval to compute the function value and J'W with new
    % set up "options"
    [F, JTW] = feval(myfun, x, [], options)





    %
    % ADIMAT
    %
    clear
    run('G:/Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/adimat/ADiMat_startup');
    addpath('G:/Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/adimat/');


    Jac = admDiffFor(@f, 1, A, c);
    admDiffFor(@func_eq,1,GUESS,PARA)
    admHessian(@f,1,A,c)
    
    
    
    %
% ADIMAT
%
run('G:/Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/adimat/ADiMat_startup');
addpath('G:/Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/adimat/');
A = magic(2);
c = [ 2 3 4 5];
v = [1,1,1];
opts = admOptions('independents', [1]);
Jac = admDiffFor(@f, 1, A, c, v, opts)

Jac = admDiffFor(@func_eq,1,GUESS,PARA)

tic
opts = admOptions('independents', [1]);
Jac = admDiffFor(@cons_eq_a_ch2,1,GUESS,  PARA.n, PARA.alpha, PARA.sigma, PARA.epsilon, PARA.delta, PARA.gamma, PARA.chi, PARA.iota, PARA.t1, PARA.m_ch, PARA.B_ch, PARA.H_ch, PARA.d0, PARA.a0, PARA.H0, PARA.B0, PARA.lambda0,PARA.w0,PARA.v0,PARA.pi0,PARA.TS0,PARA.LBAR,PARA.WBAR,PARA.TBAR,PARA.kappa_d,PARA.L0,PARA.a_ch,PARA.d_ch,PARA.PolygonNeig, PARA.NumOfLinks, PARA.omega, PARA.gammacoeff, PARA.scaling,opts );
toc

opts = admOptions('independents', [1]);
tic
Jac = admDiffComplex(@cons_eq_d_ch4,1,GUESS,  PARA.n, PARA.alpha, PARA.sigma, PARA.epsilon, PARA.delta, PARA.gamma, PARA.chi, PARA.iota, PARA.t1, PARA.m_ch, PARA.B_ch, PARA.H_ch, PARA.d0, PARA.a0, PARA.H0, PARA.B0, PARA.lambda0,PARA.w0,PARA.v0,PARA.pi0,PARA.TS0,PARA.LBAR,PARA.WBAR,PARA.TBAR,PARA.kappa_d,PARA.L0,PARA.a_ch,PARA.d_ch,PARA.PolygonNeig, PARA.NumOfLinks, PARA.omega, PARA.gammacoeff, PARA.scaling,opts );
toc
Jac

opts = admOptions('independents', [1]);
Jac = admDiffVFor(@cons_eq_d_ch4,1,GUESS,  PARA.n, PARA.alpha, PARA.sigma, PARA.epsilon, PARA.delta, PARA.gamma, PARA.chi, PARA.iota, PARA.t1, PARA.m_ch, PARA.B_ch, PARA.H_ch, PARA.d0, PARA.a0, PARA.H0, PARA.B0, PARA.lambda0,PARA.w0,PARA.v0,PARA.pi0,PARA.TS0,PARA.LBAR,PARA.WBAR,PARA.TBAR,PARA.kappa_d,PARA.L0,PARA.a_ch,PARA.d_ch,PARA.PolygonNeig, PARA.NumOfLinks, PARA.omega, PARA.gammacoeff, PARA.scaling,opts )
Jac


opts = admOptions('independents', [1]);
Jac = admDiffFD(@cons_eq_d_ch4,1,GUESS,  PARA.n, PARA.alpha, PARA.sigma, PARA.epsilon, PARA.delta, PARA.gamma, PARA.chi, PARA.iota, PARA.t1, PARA.m_ch, PARA.B_ch, PARA.H_ch, PARA.d0, PARA.a0, PARA.H0, PARA.B0, PARA.lambda0,PARA.w0,PARA.v0,PARA.pi0,PARA.TS0,PARA.LBAR,PARA.WBAR,PARA.TBAR,PARA.kappa_d,PARA.L0,PARA.a_ch,PARA.d_ch,PARA.PolygonNeig, PARA.NumOfLinks, PARA.omega, PARA.gammacoeff, PARA.scaling,opts )


admHessian(@f,1,A,c)




 
%
% ADMAT 2.0
%
run('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\ADMAT-2.0\startup.p')
addpath(genpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\ADMAT-2.0'));

cons_eq_a_ch2(GUESS,PARA);
myfun = ADfun('cons_eq_a_ch2',1);
%[f] = feval(myfun, GUESS, PARA);
options = setgradopt('revprod', 794);
tic
[F, J] = feval(myfun, GUESS, PARA, options);
toc

options = setgradopt('forwprod', 794);
tic
[F, J] = feval(myfun, GUESS, PARA, options);
toc


%%%
%%%AutoDiff Master
%%%
%
% Finite Diff
%
addpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\MatlabAutoDiff-master\src\');
f=@(x) cons_eq_a_ch2(x,PARA);
tic
JFD=full(AutoDiffJacobianFiniteDiff(f,GUESS))';
toc

%
% Opti-Toolbox
%
run('G:\Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/OPTI-master/opti_Install');
f=@(x) cons_eq_a_ch2(x,PARA);
f(GUESS)

% Numerically Differentiate
tic
df = mklJac(f,GUESS)';
toc
% Automatic Differentiation
tic
dfa = autoJac(f,GUESS)';
toc

% Complex Step Differentiation
tic
dfc = cstepJac(f,GUESS)';
toc
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
addpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\AutoDiff_R2016b\');
n=size(PARA.L0);
f=@(lambda0,w0,pi00,TS0) sum(w0.*PARA.WBAR.*lambda0.*PARA.LBAR.*PARA.t0);
x=amatinit(GUESS',1);
lambda0 =x(1:n);
w0 =x(1*n+1:2*n);
pi00=x(2*n+1:3*n);
TS0 =x(3*n+1:4*n);
V0 =x(4*n+1);
TBAR=x(4*n+2);
%[x1,x2,x3,x4] = ainit(GUESS(1:1*n,1),GUESS(1*n+1:2*n,1),GUESS(2*n+1:3*n,1),GUESS(3*n+1:4*n,1),2);
y=f(lambda0,w0,pi00,TS0);
y{0}'
JAC=ajac(y');





f=@(lambda0,w0,pi00,TS0) PARA.a0.^(1-sigma).*PARA.WBAR - w0.^(-PARA.sigma).*PARA.alpha.* ((PARA.d0.^(1-PARA.sigma)) * (((PARA.a0./(diag(PARA.d0).*w0)).^(1-PARA.sigma)).*pi00.*PARA.v0));
f=@(lambda0,w0,pi00,TS0) sum(w0.*PARA.WBAR.*lambda0.*PARA.LBAR.*PARA.t0);
[x1,x2,x3,x4] = ainit(GUESS(1:1*n,1),GUESS(1*n+1:2*n,1),GUESS(2*n+1:3*n,1),GUESS(3*n+1:4*n,1),3);
y=f(x1,x2,x3,x4);
y{1,1,1,1}


n=240
f = @(lambda0,w0) cos(2*lambda0-1)/w0;


amatinit()
f = @(u,v) u.*exp(v-u.^2-v.^2);

% initialize audi grid and evaluate
[u,v] = ndgrid(linspace(-2,2,50));
[u,v] = ainit(u,v,3);
z = f(u,v);



f(PARA.lambda0,PARA.w0,diag(PARA.pi0),PARA.TS0);
[x1,x2,x3,x4] = ainit(GUESS(1:1*n,1),GUESS(1*n+1:2*n,1),GUESS(2*n+1:3*n,1),GUESS(3*n+1:4*n,1),3);
y=f(x1,x2,x3,x4);
[y{0} y{1}]

y
aeval()


cons_eq_AD(GUESS,PARA)
[y{0} y{1}]


y=cons_gradient(GUESS,PARA);


[y{0} y{1}]

x = ainit(0.5,3);
y = f(x);
[y{0} y{1} y{2} y{3}]

ataylor(y)




tic
clear gamma
%F=@(T)((gamma((PARA.omega-1)/PARA.omega)).*((eye(PARA.n)-T.^(-PARA.omega))^(-1)).^(-1./PARA.omega));
h = 10.^(-16);

j=0;

for k=1:n
   j=j+1;

    inc_i=zeros(n,n);
    inc_i(:,k)=i*h.*PARA.PolygonNeig(:,k);

    TS=droad0+inc_i;

    F=((gamma((PARA.omega-1)/PARA.omega)).*((eye(PARA.n)-TS.^(-PARA.omega))^(-1)).^(-1./PARA.omega));

    Fpc = imag(F)/h;

    A(j,:)=reshape(Fpc,[n*n,1])';
end
toc

% Poly=repmat(reshape(PARA.PolygonNeig,[n*n,1]),[1,n*n]);
% 
% M_ij=repmat(reshape(PARA.d0,[1,n*n]),[n,1]);
% M_ih=kron(PARA.d0,ones(1,n));
% M_hj=kron(ones(1,n),PARA.d0);
% 
% droad0(PARA.PolygonNeig==0)=0;
% nom=sum(droad0,1);
% droad0(droad0>0)=1;
% denom=sum(droad0,1);
% droad0=(nom./denom)';
% 
% clear gamma
% c=gamma((PARA.omega-1)/PARA.omega);
% PARA.M=((c.*M_ij./(M_ih.*M_hj)).^(PARA.omega)).*(M_ij); %.* innerderiv(l,k);
% M_ij=[];
% M_ih=[];
% M_hj=[];
% whos
% 
% tic
% T_lk=dD0dT0_Mat(droad0,PARA).*PARA.M;
% T_lk=kron(T_lk,PARA.PolygonNeig(:,1)); % falsch
% ceq_num2=T_lk;
% toc


tic
ceq_num=dD0dT0(PARA.droad0,PARA);
ceq_diag=ceq_num*(repmat(reshape(eye(n),[n*n,1]),[1,n]).*repmat(eye(n),[n,1]));
toc




corr(ceq_num(:,1),ceq_sym(:,1))

i=1;
[ceq_sym(:,i) ceq_num(:,i) ceq_sym(:,i)-ceq_num(:,i) reshape(PARA.PolygonNeig,[n*n,1])]

corr(ceq_sym(:,i),ceq_num(:,i))

reshape(ceq_sym(5,:),[n,n])
reshape(ceq_sym(:,5),[n,n])



