function [ceq] = cons_eq (x, PARA)

if strcmp(PARA.opimization,'Productivity')~=1 & strcmp(PARA.opimization,'IncomeTrans')~=1 & strcmp(PARA.opimization,'Transport')~=1 & strcmp(PARA.opimization,'Complete')~=1
    ErrorWrongOptimizationMethode
end

% -------------------------------------------------------------------------
% Retrieve parameters from PARA
% -------------------------------------------------------------------------

alpha = PARA.alpha;
sigma = PARA.sigma;
epsilon = PARA.epsilon;
delta=PARA.delta;
gamma=PARA.gamma;
tax_contribution=PARA.tax_contribution;
iota=PARA.iota;
n=PARA.n;
chi=PARA.chi;
d0=PARA.d0;
a0=PARA.a0;
a0_BAR=PARA.a0_BAR;
H0=PARA.H0;
B0=PARA.B0;
LBAR=PARA.LBAR;
CONST=PARA.CONST;
kappa_a=PARA.kappa_a;
mu=PARA.mu;
t0=PARA.t0;

%!!!!!!!!!!!!!!!
t0=PARA.t1;
%!!!!!!!!!!!!!!!

% -------------------------------------------------------------------------
% Retrieve hat variables from input vector x
% -------------------------------------------------------------------------
if strcmp(PARA.opimizationGUESS,'Full')==1
    lambda0 =x(1:n);
    w0 =x(1*n+1:2*n);
    pi00=x(2*n+1:3*n);
    TS0 =x(3*n+1:4*n);
    V0 =x(4*n+1);
    TBAR=x(4*n+2).*PARA.TBAR;
end

if strcmp(PARA.opimizationGUESS,'Reduced')==1
        lambda0 =PARA.lambdaGUESS;
        w0 =PARA.wGUESS;
        pi00=PARA.piGUESS;
        TS0 =x(1:n);
        V0 =x(n+1);
        TBAR=x(n+2).*PARA.TBAR;
end

% -------------------------------------------------------------------------
% Retrieve other hat variables
% -------------------------------------------------------------------------
%v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+chi);
if strcmp(PARA.opimization,'IncomeTrans')==1
    v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+((TS0.*TBAR)./(lambda0.*PARA.LBAR))+chi);
end

a0=a0_BAR.*(lambda0.*LBAR).^mu;
if strcmp(PARA.opimization,'Productivity')==1
    v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+(TBAR./PARA.LBAR)+chi);
    a0=a0_BAR.*((TS0.*TBAR)./(lambda0.*PARA.LBAR)+1).^kappa_a.*(lambda0.*LBAR).^mu;
end

A=((PARA.PolygonNeig.*exp(-PARA.kappa_AA.*PARA.omega.*(PARA.droad_zero+eye(n)))));
B=inv(eye(n)-A);
d1=B.^(-1./PARA.omega).*PARA.gammacoeff;
d_ch=d1./PARA.d0;
d0=d_ch.*PARA.d0;

if strcmp(PARA.opimization,'Transport')==1
    v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+(TBAR./PARA.LBAR)+chi);
    
    T_dec=PARA.PolygonNeig.*PARA.kappa_d.*log(1+(((1./PARA.NumOfLinks).*(TS0.*TBAR))*ones(1,n)+ones(n,1)*(((1./PARA.NumOfLinks).*(TS0.*TBAR))')));
    %tinf0 = exp(PARA.kappa_AA.*PARA.PolygonNeig.*(PARA.d_zero-T_dec));
    %tinf0=PARA.PolygonNeigAdj.*abs(tinf0);
    %d1=TradeCosts(tinf0,PARA);

    A=((PARA.PolygonNeig.*exp(-PARA.kappa_AA.*PARA.omega.*(PARA.droad_zero-T_dec+eye(n)))));
    B=inv(eye(n)-A);
    d1=B.^(-1./PARA.omega).*PARA.gammacoeff;
    d_ch=d1./PARA.d0;
    d0=d_ch.*PARA.d0;
end


% -------------------------------------------------------------------------
% Compute the equilibrium conditions 
% -------------------------------------------------------------------------

COND1 = w0./PARA.w0 - (1./PARA.scaling).*(1./(lambda0.*PARA.w0)).*alpha.*(w0./a0).^(1-sigma).*((d0.^(1-sigma)) * (((a0./(diag(d0).*w0)).^(1-sigma)).*pi00.*v0.*lambda0));

COND2= pi00-diag(((d0.^(1-sigma)).*((((w0./a0).^(1-sigma)))*ones(1,n))) ./ (((d0.^(1-sigma))' * (((w0./a0).^(1-sigma))))*ones(1,n))');

income_term=((pi00).^(alpha*epsilon/(1-sigma))).*((a0.*v0./(diag(d0).*w0)).^(alpha*epsilon)).*((H0./lambda0).^((1-alpha)*epsilon));
COND3= lambda0 - ((B0).*income_term) ./ ((B0)'*income_term);

a_ch=a0./PARA.a0;
w_ch=w0./PARA.w0;
v_ch=v0./PARA.v0;
d_ch=PARA.d_ch;
pi00_ch=pi00./diag(PARA.pi0);
lambda_ch=lambda0./PARA.lambda0;

COND4=V0-(((a_ch(1).*v_ch(1))./(diag(d_ch(1)).*w_ch(1))).^(alpha)).*(pi00_ch(1).^(alpha/(1-sigma))).*((1./lambda_ch(1)).^((1-alpha)+1/epsilon));

CSTRT1 = sum(lambda0)-1;
CSTRT2 = sum(TS0)-1;
CSTRT3 = sum(w0.*lambda0.*LBAR.*t0)-TBAR;

ceq = [COND1; COND2; COND3; COND4; CSTRT1; CSTRT2; CSTRT3];

if strcmp(PARA.StableVariance,'YesNomIncome')==1
    meanVARIABLE=(1./n).*sum(sum(v0));
    
    CSTRT4 = PARA.StableVarianceVal - ((1./(n-1)).*sum(sum((v0-meanVARIABLE).^2))).^(0.5)./meanVARIABLE;
    ceq=[ceq;CSTRT4];
end

end
