function [GCeq,GRADOUT] = cons_gradient (x, PARA)

% -------------------------------------------------------------------------
% Retrieve parameters from PARA
% -------------------------------------------------------------------------
mu=PARA.mu;
alpha = PARA.alpha;
sigma = PARA.sigma;
epsilon = PARA.epsilon;
delta=PARA.delta;
gamma=PARA.gamma;
tax_contribution=PARA.tax_contribution;
iota=PARA.iota;
n=PARA.n;
chi=PARA.chi;
a0_BAR=PARA.a0_BAR;
H0=PARA.H0;
B0=PARA.B0;
LBAR=PARA.LBAR;
L0=PARA.L0;
kappa_a=PARA.kappa_a;
%t0=PARA.t0;
%!!!!!!!!!!!!!!!!
t0=PARA.t1;
%!!!!!!!!!!!!!!!!


% -------------------------------------------------------------------------
% Retrieve hat variables from input vector x
% -------------------------------------------------------------------------
lambda0 =x(1:n);
w0 =x(1*n+1:2*n);
pi00=x(2*n+1:3*n);
TS0 =x(3*n+1:4*n);
V0 =x(4*n+1,1);
TBAR=x(4*n+2).*PARA.TBAR;

% -------------------------------------------------------------------------
% Retrieve other hat variables
% -------------------------------------------------------------------------
%v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+chi);
if strcmp(PARA.opimization,'IncomeTrans')==1
    v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+((TS0.*TBAR)./(lambda0.*PARA.LBAR))+chi);
end
a0=a0_BAR.*(lambda0.*LBAR).^mu;
if strcmp(PARA.opimization,'Productivity')==1
    v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+(TBAR./PARA.LBAR)+chi);

    a0=a0_BAR.*((TS0.*TBAR)./(lambda0.*PARA.LBAR)+1).^kappa_a.*(lambda0.*LBAR).^mu;
end

A=((PARA.PolygonNeig.*exp(-PARA.kappa_AA.*PARA.omega.*(PARA.droad_zero+eye(n)))));
B=inv(eye(n)-A);
d1=B.^(-1./PARA.omega).*PARA.gammacoeff;
d_ch=d1./PARA.d0;
d0=d_ch.*PARA.d0;

if strcmp(PARA.opimization,'Transport')==1
    v0=(1./(alpha+iota-alpha.*iota)).*((1-t0).*w0+(TBAR./PARA.LBAR)+chi);

    T_dec=PARA.PolygonNeig.*PARA.kappa_d.*log(1+(((1./PARA.NumOfLinks).*(TS0.*TBAR))*ones(1,n)+ones(n,1)*(((1./PARA.NumOfLinks).*(TS0.*TBAR))')));

    A=((PARA.PolygonNeig.*exp(-PARA.kappa_AA.*PARA.omega.*(PARA.droad_zero-T_dec+eye(n)))));
    B=inv(eye(n)-A);
    d1=B.^(-1./PARA.omega).*PARA.gammacoeff;
    d_ch=d1./PARA.d0;
    d0=d_ch.*PARA.d0;
end


sumpi=repmat(((d0.^(1-sigma))' * (((w0./a0).^(1-sigma)))),1,n)';
pi00_hat=diag(((d0.^(1-sigma)).*repmat(((w0./a0).^(1-sigma)),1,n)) ./ repmat(((d0.^(1-sigma))' * (((w0./a0).^(1-sigma)))),1,n)');
pi00_hat=repmat(pi00_hat,1,n)';

income_term=((pi00).^(alpha*epsilon/(1-sigma))).*((a0.*v0./(diag(d0).*w0)).^(alpha*epsilon)).*((H0./lambda0).^((1-alpha)*epsilon));
D_hat= ((B0).*income_term) ./ ((B0)'*income_term);
D_hat=repmat(D_hat,1,n)';

lambda0=repmat(lambda0,1,n);
w0=repmat(w0,1,n);
pi00=repmat(pi00,1,n);
TS0=repmat(TS0,1,n);
v0=repmat(v0,1,n);
d00=repmat(diag(d0),1,n);
H0=repmat(H0,1,n);
B0=repmat(B0,1,n);
a0=repmat(a0,1,n);
a0_BAR=repmat(a0_BAR,1,n);

SAME1 = eye(n);

% -------------------------------------------------------------------------
% Compute partial derivatives of endogenous variables
% -------------------------------------------------------------------------

% Income
%dYdL = zeros(n);

%dYdW = repmat((1./(alpha+iota-alpha.*iota).*(1-t0)),1,n);

dYdP = zeros(n);

%dYdT = zeros(n);

dYdV = zeros(n);

%dYdTBAR = zeros(n);

%***********************
%****HERE we changed****
%***********************

if strcmp(PARA.opimization,'IncomeTrans')==1
    dYdL = -repmat((1./(alpha+iota-alpha.*iota)),1,n).*(TS0.*TBAR./(lambda0.^2.*PARA.LBAR));
    dYdW = repmat((1./(alpha+iota-alpha.*iota).*(1-t0)),1,n);
    dYdT = repmat((1./(alpha+iota-alpha.*iota)),1,n).*(TBAR./(lambda0.*PARA.LBAR));
    dYdTBAR = repmat((1./(alpha+iota-alpha.*iota)),1,n).*(TS0./(lambda0.*PARA.LBAR));
    dYdTBAR = dYdTBAR.*PARA.TBAR;
end

if strcmp(PARA.opimization,'Productivity')==1 | strcmp(PARA.opimization,'Transport')==1
    dYdL = zeros(n);
    dYdW = repmat((1./(alpha+iota-alpha.*iota).*(1-t0)),1,n);
    dYdT = zeros(n);
    dYdTBAR = repmat((1./(alpha+iota-alpha.*iota)),1,n).*(1./PARA.LBAR);
    dYdTBAR = dYdTBAR.*PARA.TBAR;
end



% Production Amenities

dAdL = mu.*a0./lambda0;

dAdW = zeros(n);

dAdP = zeros(n);

dAdT = zeros(n);

dAdV = zeros(n);

dAdTBAR = zeros(n);

if strcmp(PARA.opimization,'Productivity')==1 | strcmp(PARA.opimization,'Complete')==1
    dAdL = -a0_BAR.*kappa_a.*(TS0.*TBAR./(lambda0.*PARA.LBAR)+1).^(kappa_a-1).*(TS0.*TBAR./(lambda0.^2.*PARA.LBAR)).*(lambda0.*LBAR).^mu + a0./lambda0.*mu;
    dAdW = zeros(n);
    dAdP = zeros(n);
    dAdT = a0_BAR.*kappa_a.*(TS0.*TBAR./(lambda0.*PARA.LBAR)+1).^(kappa_a-1).*(lambda0.*LBAR).^mu.*(TBAR./(lambda0.*PARA.LBAR));
    dAdV = zeros(n);
    dAdTBAR = a0_BAR.*kappa_a.*(TS0.*TBAR./(lambda0.*PARA.LBAR)+1).^(kappa_a-1).*(lambda0.*LBAR).^mu.*(TS0./(lambda0.*PARA.LBAR));
    dAdTBAR = dAdTBAR.*PARA.TBAR;
end

% -------------------------------------------------------------------------
% Compute partial derivatives of CA equilibrium constraints
% -------------------------------------------------------------------------

%****!!!!!!!!!!!!!!!!
PARAw0=repmat(PARA.w0,1,n);
%****!!!!!!!!!!!!!!!!

CA_hat= (1./PARA.scaling).*(1./(lambda0.*PARAw0)).*(w0./a0).^(1-sigma).*alpha.* ((d0.^(1-sigma)) * (((a0./(d00.*w0)).^(1-sigma)).*pi00.*v0.*lambda0));
CA_hat_onlyKTerms= (1./PARA.scaling).*(1./(lambda0'.*PARAw0')).*(w0'./a0').^(1-sigma).*alpha.*((d0.^(1-sigma)).*(((a0./(d00.*w0)).^(1-sigma)).*pi00.*v0.*lambda0));

dCAdL = (1./lambda0).*CA_hat.*SAME1 + (1-sigma).*CA_hat.*(1./a0).*dAdL.*SAME1 - CA_hat_onlyKTerms.*((1-sigma).*(1./a0).*dAdL + (1./v0).*dYdL + (1./lambda0));

dCAdW = (1./PARAw0).*SAME1 - (1-sigma)*CA_hat./w0.*SAME1 - CA_hat_onlyKTerms.*(-(1-sigma).*1./w0+ 1./v0.*dYdW);

dCAdP = - CA_hat_onlyKTerms.*(1./pi00);

dCAdT = (1-sigma)*CA_hat./a0.*dAdT.*SAME1 - CA_hat_onlyKTerms.*((1-sigma).*1./a0.*dAdT + 1./v0.*dYdT);

dCAdV = zeros(n);

dCAdTBAR = (1-sigma).*CA_hat./a0.*dAdTBAR.*SAME1 - repmat(sum((1-sigma).*CA_hat_onlyKTerms./a0.*dAdTBAR,1),[n,1]) - repmat(sum(CA_hat_onlyKTerms./v0.*dYdTBAR,1),[n,1]);
dCAdTBAR = diag(dCAdTBAR)';

% -------------------------------------------------------------------------
% Compute partial derivatives of CB equilibrium constraints
% -------------------------------------------------------------------------

dCBdL = (1-sigma).*pi00_hat./a0.*dAdL.*SAME1 - (1-sigma)./sumpi.^2 .* ((d00.*w0./a0).^(1-sigma))' .* (d0.*w0./a0).^(1-sigma) ./ a0 .*dAdL;

dCBdW = -(1-sigma).*pi00_hat./w0.*SAME1 + (1-sigma)./sumpi.^2 .* ((d00.*w0./a0).^(1-sigma))' .* (d0.*w0./a0).^(1-sigma)./w0;

dCBdP = SAME1;

dCBdT = (1-sigma).*pi00_hat./a0.*dAdT.*SAME1 - (1-sigma)./sumpi.^2 .* ((d00.*w0./a0).^(1-sigma))' .* (d0.*w0./a0).^(1-sigma) ./ a0 .*dAdT;

dCBdV = zeros(n);

dCBdTBAR =  (1-sigma).*pi00_hat./a0.*dAdTBAR.*SAME1 - repmat(sum((1-sigma).*((d0.^(1-sigma))'.*((w0./a0).^(1-sigma).*a0.^(-1).*dAdTBAR)) .* pi00_hat .* sumpi.^(-1),1),[n,1]);
dCBdTBAR = diag(dCBdTBAR)';

% -------------------------------------------------------------------------
% Compute partial derivatives of CC equilibrium constraints
% -------------------------------------------------------------------------

dCCdL = SAME1 + ((1-alpha)*epsilon).*D_hat'.*(1./lambda0'.*SAME1 - D_hat./lambda0) - (alpha*epsilon).*D_hat'.*(1./a0'.*dAdL.*SAME1 - D_hat./a0.*dAdL + 1./v0'.*dYdL.*SAME1 - D_hat./v0.*dYdL);

dCCdW = (alpha*epsilon).*D_hat'.*(1./w0'.*SAME1 - 1./v0'.*dYdW.*SAME1 - D_hat./ w0 + D_hat./ v0 .*dYdW);

dCCdP = -(alpha*epsilon)/(1-sigma).*D_hat'.*(1./pi00'.*SAME1 - D_hat ./ pi00);

dCCdT = - (alpha*epsilon).*D_hat'.*(1./a0'.*dAdT.*SAME1 - D_hat./a0.*dAdT + 1./v0'.*dYdT.*SAME1 - D_hat./v0.*dYdT);

dCCdV = zeros(n);

dCCdTBAR =  - (alpha.*epsilon).*D_hat'.*(1./a0'.*dAdTBAR.*SAME1) + repmat(sum((alpha.*epsilon).*D_hat'.*D_hat./a0.*dAdTBAR,1),[n,1]) - (alpha.*epsilon).*D_hat'.*(1./v0'.*dYdTBAR.*SAME1) + repmat(sum((alpha.*epsilon).*D_hat'.*D_hat./v0.*dYdTBAR,1),[n,1]);
dCCdTBAR = diag(dCCdTBAR)';

% -------------------------------------------------------------------------
% Compute partial derivatives of CD equilibrium constraints
% -------------------------------------------------------------------------

a_ch=a0./repmat(PARA.a0,[1,n]);
w_ch=w0./repmat(PARA.w0,[1,n]);
v_ch=v0./repmat(PARA.v0,[1,n]);
d_ch=PARA.d_ch;
pi00_ch=pi00./repmat(diag(PARA.pi0),[1,n]);
lambda_ch=lambda0./repmat(PARA.lambda0,[1,n]);

V0_hat=(((a_ch.*v_ch)./(d_ch.*w_ch)).^(alpha)).*pi00_ch.^(alpha/(1-sigma)).*((1./lambda_ch).^((1-alpha)+1/epsilon));

dCDdL = ((1-alpha)*(1-sigma)*epsilon+(1-sigma))/((1-sigma)*epsilon).*V0_hat./lambda0.*SAME1 - alpha.*V0_hat./a0.*dAdL.*SAME1 - alpha.*V0_hat./v0.*dYdL.*SAME1;

dCDdW = -alpha.*V0_hat./v0.*dYdW.*SAME1 + alpha.*V0_hat./w0.*SAME1;

dCDdP = -(alpha/(1-sigma)).*V0_hat./pi00.*SAME1;

dCDdT = -alpha.*V0_hat./a0.*dAdT.*SAME1 -alpha.*V0_hat./v0.*dYdT.*SAME1;

dCDdV = ones(n,n);

dCDdTBAR = -alpha.*V0_hat./a0.*dAdTBAR -alpha.*V0_hat./v0.*dYdTBAR;
dCDdTBAR = diag(dCDdTBAR)';

% -------------------------------------------------------------------------
% Form the JACOBIAN
% -------------------------------------------------------------------------

dCDdV = dCDdV(1,:);
dCDdTBAR = dCDdTBAR(1,:);
dCAdV = dCAdV(1,:);
dCAdTBAR = dCAdTBAR(1,:);
dCBdV = dCBdV(1,:);
dCBdTBAR = dCBdTBAR(1,:);
dCCdV = dCCdV(1,:);
dCCdTBAR = dCCdTBAR(1,:);

dA= [dCDdL; dCDdW; dCDdP; dCDdT; dCDdV; dCDdTBAR];
dB= [dCAdL; dCAdW; dCAdP; dCAdT; dCAdV; dCAdTBAR];
dC= [dCBdL; dCBdW; dCBdP; dCBdT; dCBdV; dCBdTBAR];
dD= [dCCdL; dCCdW; dCCdP; dCCdT; dCCdV; dCCdTBAR];

dA=dA(:,1);
dB=dB(:,:);
dC=dC(:,:);
dD=dD(:,:);

dCSTR1=zeros(4*n+2,1);
dCSTR1(1:n,1)=1;

dCSTR2=zeros(4*n+2,1);
dCSTR2(3*n+1:4*n)=1;

dCSTR3=zeros(4*n+2,1);
dCSTR3(1:n)=w0(:,1).*LBAR.*t0(:,1);
dCSTR3(1*n+1:2*n)=lambda0(:,1).*LBAR.*t0(:,1);
dCSTR3(4*n+2)= -1 .* PARA.TBAR;

JACOBIAN = [dB, dC, dD, dA, dCSTR1, dCSTR2, dCSTR3];



if strcmp(PARA.StableVariance,'YesNomIncome')==1
    
    SUMv0=sum(v0,1);
    SUMv0=SUMv0(1,1);
    meanVARIABLE=(1./n).*SUMv0;
    VarVARIABLE=((1./(n-1)).*sum(sum((diag(v0)-meanVARIABLE).^2)));
    
    dCSTRT4dL=-diag((1./(n-1)).*(1./VarVARIABLE.^0.5).*(v0.*dYdL - meanVARIABLE.*dYdL)./meanVARIABLE) + diag((VarVARIABLE.^0.5./(meanVARIABLE.^2)).*((1./n).*dYdL));
    dCSTRT4dW=-diag((1./(n-1)).*(1./VarVARIABLE.^0.5).*(v0.*dYdW - meanVARIABLE.*dYdW)./meanVARIABLE) + diag((VarVARIABLE.^0.5./(meanVARIABLE.^2)).*((1./n).*dYdW));
    dCSTRT4dP=-zeros(n,1);
    dCSTRT4dT=-diag((1./(n-1)).*(1./VarVARIABLE.^0.5).*(v0.*dYdT - meanVARIABLE.*dYdT)./meanVARIABLE) + diag((VarVARIABLE.^0.5./(meanVARIABLE.^2)).*((1./n).*dYdT));
    dCSTRT4dV=-0;
    dCSTRT4dTBAR=-sum(diag((1./(n-1)).*(1./VarVARIABLE.^0.5).*(v0.*dYdTBAR - meanVARIABLE.*dYdTBAR)./meanVARIABLE) - diag((VarVARIABLE.^0.5./(meanVARIABLE.^2)).*((1./n).*dYdTBAR)));
    
    dCSTRT4=[dCSTRT4dL;dCSTRT4dW;dCSTRT4dP;dCSTRT4dT;dCSTRT4dV;dCSTRT4dTBAR];
    
    JACOBIAN=[JACOBIAN, dCSTRT4];
end


GCeq = JACOBIAN;

GRADOUT.dCDdL = dCDdL;
GRADOUT.dCDdW = dCDdW;
GRADOUT.dCDdP = dCDdP;
GRADOUT.dCDdT = dCDdT;
GRADOUT.dCDdV = dCDdV;

GRADOUT.dCAdL = dCAdL;
GRADOUT.dCAdW = dCAdW;
GRADOUT.dCAdP = dCAdP;
GRADOUT.dCAdT = dCAdT;
GRADOUT.dCAdV = dCAdV;

GRADOUT.dCBdL = dCBdL;
GRADOUT.dCBdW = dCBdW;
GRADOUT.dCBdP = dCBdP;
GRADOUT.dCBdT = dCBdT;
GRADOUT.dCBdV = dCBdV;

GRADOUT.dCCdL = dCCdL;
GRADOUT.dCCdW = dCCdW;
GRADOUT.dCCdP = dCCdP;
GRADOUT.dCCdT = dCCdT;
GRADOUT.dCCdV = dCCdV;

GRADOUT.dYdL = dYdL;
GRADOUT.dYdW = dYdW;
GRADOUT.dYdP = dYdP;
GRADOUT.dYdT = dYdT;
GRADOUT.dYdV = dYdV;

GRADOUT.dCSTR2 = dCSTR2;
GRADOUT.dCSTR1 = dCSTR1;

GRADOUT.V0_HAT = V0_hat;

end
