function [c, ceq, GC, GCeq] = optcons(x, PARA)
    c    = [];

    ceq = cons_eq(x,PARA);

    GC   = [];
    
    GCeq=cons_gradient(x,PARA);

    if strcmp(PARA.opimization,'Transport')==1 | strcmp(PARA.opimization,'Complete')==1
        n=PARA.n;
        
        PARA.opimizationGUESS='Reduced';
        
        %Decrease the size of the GUESS, because we only need the
        %derivative with repsect to TS, V, and TBAR
        PARA.lambdaGUESS = x(1:1*n,1); 
        PARA.wGUESS = x(1*n+1:2*n,1);
        PARA.piGUESS = x(2*n+1:3*n,1);

        GUESS2 = [];
        GUESS2(1:1*n,1) = x(3*n+1:4*n,1); %ones(n,1); %TS_ch
        GUESS2(n+1,1) =  x(4*n+1); %V_ch
        GUESS2(n+2,1) =  x(4*n+2); %TBAR_ch
        
        %myfun = ADfun('cons_eq',1);
        %options = setopt('forwprod', eye(size(GUESS2,1))); %% forwprod, revprod
        %[F, GCeq2] = feval(myfun, GUESS2, PARA, options);
        %GCeq2=GCeq2';
        
        % Automatic Differentiation
        x=deriv(GUESS2,eye(size(GUESS2,1)));
        y=cons_eq(x,PARA);
        GCeq2=getydot(y);        
        GCeq2=GCeq2';

        GCeq(size(GCeq,1) - size(GCeq2,1) +1:size(GCeq,1),:)=GCeq2;
        
        PARA.opimizationGUESS='Full';
        
    end
    
    % Automatic Differentiation
    %addpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\MatlabAutoDiff-master\src\');
    %f=@(x) cons_eq(x,PARA);
    %GCeq=full(AutoDiffJacobianAutoDiff(f,x))';    
    
    %ADMAT-2.0
    %run('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\ADMAT-2.0\startup.p')
    %addpath(genpath('G:\Public Economics\Forschung\GRW Projekt\Paper\Redding Replication\functions\ADMAT-2.0'));
    
    %     myfun = ADfun('cons_a_eq',1);
    %     options = setgradopt('forwprod', size(x,1));
    %     [F, GCeq] = feval(myfun, x, PARA, options);
    %     GCeq=GCeq';
    
    %Adimat
    %run('G:/Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/adimat/ADiMat_startup');
    %addpath('G:/Public Economics/Forschung/GRW Projekt/Paper/Redding Replication/functions/adimat/');

    %Jac = admDiffFor(@f, 1, A, c);
    %admDiffFor(@cons_eq_a_ch2,1,x,PARA)
    %admDiffRev(@cons_eq_a_ch2,1,x,PARA)
    %admHessian(@f,1,A,c)
    
    
    %Hardcoded
    %Jac=cons_eq_a_ch2_Jac(x,PARA);
    %Jac=full(Jac)';

    % Numerically Differentiate
    %tic
    %df = mklJac(f,x)';
    %toc

    % Complex Step Differentiation
    %GCeq = cstepJac(f,x)';
    
    %GCeq=cons_eq_a_ch3_Jac(x,PARA);
    
    
    %Write x raus in ein TXT
    
end
