function [U,PARA]=solveCounterfactual_d(PARA)

    mu=PARA.mu;			   
    alpha=PARA.alpha;
    sigma=PARA.sigma;
    epsilon=PARA.epsilon;
    delta=PARA.delta;
    gamma=PARA.gamma;
    iota=PARA.iota;

    chi=PARA.chi;    
    TS1=PARA.TS1; 
    
    n=size(PARA.L0,1);

    w_ch=ones(n,1);
    v_ch=ones(n,1);
    lambda_ch=ones(n,1);
    pi_ch=ones(n,n);
    lambda_ch_l=ones(n,1);
    w_ch_l=ones(n,1);
    
    v0=PARA.v0;
    lambda0=PARA.lambda0;
    w0=PARA.w0;
    t1=PARA.t1;
    pi0=PARA.pi0;
    
    LBAR=PARA.LBAR;

    m_ch=PARA.m_ch;
    B_ch=PARA.B_ch;
    d_ch=PARA.d_ch;
    a_ch=PARA.a_ch;
    a_ch_exo=PARA.a_ch;
	
    H_ch=PARA.H_ch;
    
	error2=1;
    i=0;
    f=0;
	j=0;
    
    w_ch_ll=ones(n,1);
    lambda_ch_ll=ones(n,1);
    scaling=1;
    
   ii=1;
   vfact=0.2;
   prec=1000;

   while (i <= 10 || ii <= 500 || (j>1 || f>1))

       if i>10000
          stop 
       end
       
        i=i+1;        
        if (j==1 && f==1)
            ii=ii+1;
        end
        
        L111=lambda_ch.*lambda0.*PARA.LBAR;
        
        TBAR=sum(w_ch.*w0.*lambda_ch.*lambda0.*LBAR.*t1);
        
        housingExp=(1-alpha)*v_ch.*v0.*lambda_ch.*lambda0.*LBAR;
        chi=(sum(iota.*housingExp))./sum(LBAR);

        %Income and Productivity without Transfers
        v_ch=(1./v0).*(1./(iota+alpha-alpha.*iota)).*(w_ch.*w0.*(1-t1)+TBAR./PARA.LBAR+chi);
        a_ch=(PARA.a0_BAR.*(lambda_ch.*PARA.L0).^mu)./PARA.a0;

        T_dec=PARA.PolygonNeig.*PARA.kappa_d.*log(1+(repmat((1./PARA.NumOfLinks).*(TS1.*TBAR),[1,n])+repmat(((1./PARA.NumOfLinks).*(TS1.*TBAR))',[n,1])));
        TIME=PARA.droad_zero-T_dec;
        tinf0 = exp(PARA.kappa_AA.*PARA.PolygonNeig.*(TIME));
        tinf0(PARA.PolygonNeig==0)=inf;
        
        d1=TradeCosts(tinf0,PARA);
        d_ch=d1./PARA.d0;
        
        j=0;
        error1=1;
        while (error1 >= 1e-6 & j<2000)
            j=j+1;
            
            pi_ch=((d_ch.^(1-sigma)).*(repmat(((w_ch_l./a_ch).^(1-sigma))',[n,1]))) ./ (repmat(sum(((d_ch.^(1-sigma)).*(repmat(((w_ch_l./a_ch).^(1-sigma))',[n,1]))).*pi0,2),[1,n]));
            
            w_ch_ll=alpha.*(sum(pi_ch.*pi0.*(repmat(v_ch.*v0.*lambda_ch.*lambda0,[1,n])),1)'./(lambda_ch.*(alpha.*sum(pi0.*repmat(lambda0.*v0,[1,n]),1)')));
            w_ch_ll=(1./scaling).*alpha.*(sum(pi_ch.*pi0.*(repmat(v_ch.*v0.*lambda_ch.*lambda0,[1,n])),1)'./(lambda_ch.*lambda0.*w0));
            
            error1 = sum(abs(w_ch_ll-w_ch_l));
            
            %Diagnostics
            if j>=1 && mod(j,1)==0
                %disp(['i: ' num2str(i) ' j: ' num2str(j) ' f: ' num2str(f)  ', Diff Res Error 1: ' num2str(error1)  ', Diff Res Error 2: ' num2str(error2) ', w_ch(1): ' num2str(w_ch_l(1)) ', L_ch(1): ' num2str(lambda_ch(1))]);
            end
            
            w_ch_l=(1-vfact).*w_ch_l+vfact.*w_ch_ll;
        end;
            
        f=0;
        error2=1;
        
        while (error2 >= 1e-20 & f<2000)
            f=f+1;
            
            pi_ch=((d_ch.^(1-sigma)).*(repmat(((w_ch./a_ch).^(1-sigma))',[n,1]))) ./ (repmat(sum(((d_ch.^(1-sigma)).*(repmat(((w_ch./a_ch).^(1-sigma))',[n,1]))).*pi0,2),[1,n]));

            income_term=(B_ch./m_ch.^(PARA.epsilon)).*((diag(pi_ch)).^(alpha*epsilon/(1-sigma))).*((a_ch.*v_ch./(w_ch.*diag(d_ch))).^(alpha*epsilon)).*((H_ch./lambda_ch_l).^((1-alpha)*epsilon));
            lambda_ch_ll=income_term ./ (sum(sum(income_term.*lambda0)));
            
            error2 = sum((lambda_ch_ll-lambda_ch_l).^2);

            %Diagnostics
            if f>=1 && mod(f,10)==0
                %disp(['i: ' num2str(i) ', j: ' num2str(j) ', f: ' num2str(f) ', prueba_w: ' num2str(error1) ', prueba_L: ' num2str(error2)]);
            end
            lambda_ch_l=(1-vfact).*lambda_ch_l+vfact.*lambda_ch_ll;
        end;

        error1_lev = (scaling.*w_ch-1./(lambda_ch.*w0.*lambda0).*alpha.*(sum(pi_ch.*pi0.*(repmat(v_ch.*v0.*lambda_ch.*lambda0,[1,n])),1)'));

         if mean(error1_lev)<0
             scaling=scaling+abs(mean(error1_lev));
         else
             scaling=scaling-abs(mean(error1_lev));
         end
        
        w_ch_l=w_ch_l./mean(w_ch_l);
        w_ch=w_ch_l;
       
        lambda_ch=lambda_ch_l;

        income_term=(B_ch./m_ch.^(PARA.epsilon)).*((diag(pi_ch)).^(alpha*epsilon/(1-sigma))).*((a_ch.*v_ch./(w_ch.*diag(d_ch))).^(alpha*epsilon)).*((H_ch./lambda_ch).^((1-alpha)*epsilon));
        error2_lev=(lambda_ch-income_term ./ (sum(sum(income_term.*lambda0))));

        if mod(i,100)==0 || i<10
            disp(['i: ' num2str(i) ' j: ' num2str(j) ' f: ' num2str(f)  ', Diff Res Error w: ' num2str(error1) ', Res Error w: ' num2str(sum(abs(error1_lev))) ', Max Res Error w: ' num2str(max(abs(error1_lev))) ', Diff Res Error L: ' num2str(error2)  ', Res Error L: ' num2str(sum(abs(error2_lev))) ', Max Res Error L: ' num2str(max(abs(error2_lev))) ', w_ch(1): ' num2str(w_ch(1)) ', L_ch(1): ' num2str(lambda_ch(1))]);
        end
   end

    disp(['i: ' num2str(i) ', j: ' num2str(j) ', f: ' num2str(f) ', prueba_w: ' num2str(error1) ', prueba_L: ' num2str(error2)]);
    disp('Sum of tax revenue vs. place-based policy expenditure')    
    [sum(w_ch.*w0.*lambda_ch.*lambda0.*LBAR.*t1), TBAR, sum(w_ch.*w0.*lambda_ch.*lambda0.*LBAR.*t1)- TBAR]
    
    Utility_ch=(B_ch./m_ch.^epsilon).^(1/epsilon).*(v_ch.*a_ch./(w_ch.*diag(d_ch))).^alpha.*(diag(pi_ch).^(alpha/(1-sigma))).*((1./lambda_ch).^(1/epsilon+1-alpha));
    U=Utility_ch;
    
    PARA.scaling=scaling;
    PARA.U_ch=Utility_ch;    
    PARA.w_ch=w_ch;
    PARA.v_ch=v_ch;
	PARA.a_ch=a_ch;
    PARA.d_ch=d_ch;
    PARA.lambda_ch=lambda_ch;
    PARA.pi_ch=pi_ch;
    PARA.L_ch=PARA.lambda_ch;
    PARA.P_ch=(PARA.L_ch./diag(PARA.pi_ch)).^(1./(1-PARA.sigma)).*diag(PARA.d_ch).*PARA.w_ch./PARA.a_ch;
    PARA.r_ch=(PARA.v_ch.*PARA.L_ch);
    PARA.TBAR_ch=TBAR./PARA.TBAR;  

end