function [B0] = solveRecoverMigrationCosts(B0_init,lambda0,w0,d0,a0,pi0,H0,v0,PARA)
    
    n=size(lambda0,1);
    alpha=PARA.alpha;
    sigma=PARA.sigma;
    epsilon=PARA.epsilon;

    error1=1;
    x0_l=B0_init;
    i=0;

    while (error1 >= 1e-25)
        i = i+1;
        income_term=((diag(pi0)).^(alpha*epsilon/(1-sigma))).*((a0.*v0./(diag(d0).*w0)).^(alpha*epsilon)).*((H0./lambda0).^((1-alpha)*epsilon));

        RHS=((lambda0.*(x0_l'*income_term))./(income_term));
        x0_ll=RHS;
        
        error1 = sum((x0_ll-x0_l).^2);
        
        %Diagnostics
        if i>=1
            if mod(i,1)==0 | i<5
                disp(['i: ' num2str(i) ', Improvement: ' num2str(error1)]);
            end
        end
        
        x0_l=x0_ll;
    end;

    disp(['i: ' num2str(i) ', Improvement: ' num2str(error1)]);
    B0=x0_l;

end